#include <WebKit2/WKBundleInitialize.h>
#include <WebKit2/WKBundleFrame.h>
#include <Webkit2/WKBundlePage.h>
#include <WebKit2/WKBundle.h>
#include <Webkit2/WKUrl.h>
#include <Webkit2/WKString.h>
#include <windows.h>
#include <string.h>
#include <wchar.h>

#pragma comment(lib, "WebKit.lib")


void didFinishLoadForFrame(WKBundlePageRef, WKBundleFrameRef frame, WKTypeRef*, const void*)
{
	if (WKBundleFrameIsMainFrame(frame))
	{
		WKURLRef url = WKBundleFrameCopyURL(frame); // URL
		WKStringRef str = WKURLCopyString(url); // õURLַ
		size_t length = WKStringGetLength(str);
		wchar_t* urlBuffer = new wchar_t[length + 1];
		size_t size = WKStringGetCharacters(str, urlBuffer, length); // תwchar_t*
		urlBuffer[length] = 0;
		
		WKRect rect = WKBundleFrameGetContentBounds(frame); // õ߽緶Χ
		wchar_t info[1024];
		swprintf(info, L"url: %s\nx=%f, y=%f, width=%f, height=%f",
			urlBuffer, rect.origin.x, rect.origin.y, rect.size.width, rect.size.height); // ɽ
		::MessageBoxW(0, info, L"FrameBound", MB_OK); // ʾ
		delete[] urlBuffer;
	}
}

// page
void didCreatePage(WKBundleRef bundle, WKBundlePageRef page, const void*)
{
	WKBundlePageLoaderClient loaderClient = { 0 };
	loaderClient.version = kWKBundlePageLoaderClientCurrentVersion;
	loaderClient.didFinishLoadForFrame = didFinishLoadForFrame; // עص
	WKBundlePageSetPageLoaderClient(page, &loaderClient);
}

extern "C" __declspec(dllexport)
void WKBundleInitialize(WKBundleRef bundle, WKTypeRef initializationUserData)
{
	WKBundleClient client = { 0 };
	client.version = kWKBundleClientCurrentVersion;
	client.didCreatePage = didCreatePage;
	WKBundleSetClient(bundle, &client);
}