#include <Windows.h>
#include <Webkit2/WKType.h>
#include <WebKit2/WKStringCF.h>
#include <Webkit2/WKString.h>
#include <Webkit2/WKUrl.h>
#include <Webkit2/WKView.h>
#include <Webkit2/WKContext.h>
#include <Webkit2/WKPage.h>
#include <shlwapi.h>
#include <WebKit2/WKURLCF.h>

#pragma comment(lib, "Shlwapi.lib")
#pragma comment(lib, "CoreFoundation.lib")
#pragma comment(lib, "WebKit.lib")


WKStringRef getBundlePath()
{
	const wchar_t* THIS_FILE_NAME = L"WebkitDemo.exe";				// ͻļ
	const wchar_t* BUNDLE_FILE_NAME = L"MyInjectedBundle.dll";		// InjectedBundleļ
	HMODULE thisModule = ::GetModuleHandleW(THIS_FILE_NAME);
	if (!thisModule)
		return 0;

	WCHAR pathStr[MAX_PATH];
	if (!::GetModuleFileNameW(thisModule, pathStr, (DWORD)wcslen(pathStr)))		// õͻļ·
		return 0;

	::PathRemoveFileSpecW(pathStr);						// ȥļ
	if (!::PathAppendW(pathStr, BUNDLE_FILE_NAME))		// InjectedBundleļ
		return 0;

	CFStringRef cf = CFStringCreateWithCharacters(0, (const UniChar*)pathStr, (CFIndex)wcslen(pathStr));

	WKStringRef res = WKStringCreateWithCFString(cf);

	CFRelease(cf);

	return res;
}

void goToURL(const wchar_t* wcurl, WKViewRef view)
{
	CFStringRef string = CFStringCreateWithCharacters(0, (const UniChar*)wcurl, (CFIndex)wcslen(wcurl));
	CFStringRef escapedString = CFURLCreateStringByAddingPercentEscapes(0, string, 0, 0, kCFStringEncodingUTF8);
	CFRelease(string);
	CFURLRef cfURL = CFURLCreateWithString(0, escapedString, 0);
	CFRelease(escapedString);
	WKURLRef url = WKURLCreateWithCFURL(cfURL);		// һURL
	CFRelease(cfURL);
	WKPageRef page = WKViewGetPage(view);
	WKPageLoadURL(page, url);						// ʼ
	WKRelease(url);
}

void createView(HWND window)
{
	RECT webViewRect = { 0, 0, 0, 0 };
	WKStringRef path = getBundlePath();
	WKContextRef context = WKContextCreateWithInjectedBundlePath(path);		// InjectedBundlecontext
	WKRelease(path);

	WKViewRef view = WKViewCreate(webViewRect, context, 0, window);	// view
	WKViewSetIsInWindow(view, true);
	// WKPageSetXXXClientעһЩص
	goToURL(L"http://www.baidu.com", view);
}

LRESULT CALLBACK runLoopProc(HWND window, UINT message, WPARAM wParam, LPARAM lParam)
{
	if (message == WM_CREATE) 
	{
		createView(window);			// view֮
		return 0;
	}
	return ::DefWindowProc(window, message, wParam, lParam);
}

int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPWSTR lpstrCmdLine, int nCmdShow)
{
	MSG msg;
	BOOL bRet;

	WNDCLASS wc;
	wc.style = 0;
	wc.lpfnWndProc = runLoopProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon((HINSTANCE) NULL, IDI_APPLICATION);
	wc.hCursor = LoadCursor((HINSTANCE) NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName = 0;
	wc.lpszClassName = L"MyWebkitToolRunLoop";

	if (!RegisterClass(&wc))
		return 0;

	HWND hwnd = ::CreateWindow(L"MyWebkitToolRunLoop", L"MyWebkitTool",
		WS_OVERLAPPED, CW_USEDEFAULT, CW_USEDEFAULT,
		CW_USEDEFAULT, CW_USEDEFAULT, 0, 0, hInstance, 0);

	if (!hwnd)
		return 0;

	// ʼϢѭ

	while ( (bRet = GetMessage( &msg, NULL, 0, 0 )) != 0)
	{
		if (bRet == -1)
		{
			break;
		}
		else
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return 0;
}